﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc {
  using System;
  using Core;

  public interface IErcItem : IItem {
    event EventHandler<bool> EnabledChanged;
    bool IsEnabled { get; set; }
  }

  public interface IErcItem<out T> : IErcItem {
    T GetErcValue(IRandom random);
  }

  public interface IWeightedErcItem : IErcItem, IWeighted { }

  public interface IWeightedErcItem<out T> : IErcItem<T>, IWeightedErcItem { }
}
