﻿using System.Collections.Generic;

namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
  using System;

  [Serializable]
  public class PooledList<T> : List<T>, IPooledObject {
    public Guid Id { get; private set; }

    void IPooledObject.Init() {
      Id = Guid.NewGuid();
    }

    void IPooledObject.Reset() {
      Clear();
    }
  }
}
