﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;

  [StorableClass]
  public class PlushEntry : Item {
    public PlushEntry() { }

    public PlushEntry(bool deserializing) : base(deserializing) { }

    public PlushEntry(PlushEntry origin, Cloner cloner) : base(origin, cloner) {
      Instruction = cloner.Clone(origin.Instruction);
      Close = origin.Close;
    }

    [Storable]
    public Expression Instruction { get; set; }
    [Storable]
    public int Close { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlushEntry(this, cloner);
    }
  }
}
