﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator {
  using HeuristicLab.Core;
  using HeuristicLab.Data;
  using HeuristicLab.Optimization;
  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;

  public interface IPlushCreator : ISolutionCreator, IPlushOperator {
    IValueLookupParameter<IntValue> MinLengthParameter { get; }
    IValueLookupParameter<IntValue> MaxLengthParameter { get; }
    IValueLookupParameter<IntValue> MinCloseParameter { get; }
    IValueLookupParameter<IntValue> MaxCloseParameter { get; }
    IValueLookupParameter<DoubleValue> CloseBiasLevelParameter { get; }
    IValueLookupParameter<PercentValue> InInstructionProbabilityParameter { get; }
    IValueLookupParameter<IReadOnlyErcOptions> ErcOptionsParameter { get; }
    IValueLookupParameter<IReadOnlyExpressionsConfiguration> InstructionsParameter { get; }
    ILookupParameter<PlushVector> PlushVectorParameter { get; }
  }
}
